      program edo
      
      integer n
      real*8 d(10000),sub(10000),sup(10000),b(10000),a,c,h,k,err,y0,err1
      data a,c /0.,1./
      open(20,file='edo1.doc',status='unknown')
      
      write(20,'(a4,10x,a1,9x,a2,9x,a4,6x,a11)') 'k','h','ym','E(k)'
     a,'E(k-1)/E(k)' 
      write(*,'(a4,10x,a1,9x,a2,9x,a4,6x,a11)') 'k','h','ym','E(k)'
     a,'E(k-1)/E(k)' 
      write(20,*)
      write(*,*)
      
      do k=1,8
        
        h=2**(-1-k)
        n=(c-a)/h
        
      call matriz(d,sub,sup,h,n)
      call coef(b,h,n)
      
      call lu(n,d,sub,sup)
      call solve(n,d,sub,sup,b)
       
       if(k.eq.1) then
        y0=b(n/2)    
        write(20,'(f5.1,f13.8,f11.8)') k,h,b(n/2)
        write(*,'(f5.1,f13.8,f11.8)') k,h,b(n/2)  
       else 
         err=abs(b(n/2)-y0)/abs(b(n/2))
         
         if(k.eq.2) then
          
          write(20,'(f5.1,f13.8,f11.8,e13.6)') k,h,b(n/2),err
          write(*,'(f5.1,f13.8,f11.8,e13.6)') k,h,b(n/2),err 
          
          err1=err
         else
           err1=err1/err
           
      write(20,'(f5.1,f13.8,f11.8,e13.6,f13.8)') k,h,b(n/2),err,err1
      write(*,'(f5.1,f13.8,f11.8,e13.6,f13.8)') k,h,b(n/2),err,err1 
           err1=err
         endif
       endif
       y0=b(n/2)
        
      enddo
            
      close(20)
      
      end
      
      subroutine matriz(d,sub,sup,h,n)
      
      real*8 d(10000),sub(10000),sup(10000),h
      integer i,n
      
      do i=1,n-1
        d(i)=-2-3*h*h  
      enddo
        d(n)=-2-3*h*h-2*h*(1+h*h*(n-1)/2)
        
      do i=1,n-1
        sup(i)=1+h*h*i/2
      enddo
       sup(n)=0
       sub(1)=0
       
      do i=2,n-1
        sub(i)=1-h*h*i/2
      enddo
      
      sub(n)=2.
      
      return
      end
      
      subroutine coef(b,h,n)
      
      real*8 b(10000),h
      integer i,n
      
      b(1)=-1.
      
      do i=2,n-1
        b(i)=(h**4)*i*i*exp(-h*i)
      enddo
      
      b(n)=(h**4)*((n-1)**2)*exp(-h*(n-1))-2*h*(1+h*h*(n-1)/2)
      
      return
      end
      
      subroutine lu(n,d,sub,sup)
      
      real*8 d(10000),sub(10000),sup(10000)
      
      do i=2,n
        sup(i-1)=sup(i-1)/d(i-1)
        d(i)=d(i)-sub(i)*sup(i-1)
      enddo  
         
      return
      end
      
      subroutine solve(n,d,sub,sup,b)
      
      real*8 d(10000),sub(10000),sup(10000),b(10000)
      integer i,n
      
      b(1)=b(1)/d(1)
      
      do i=2,n
        b(i)=b(i)-sub(i)*b(i-1)
        b(i)=b(i)/d(i)
      enddo
        
      do i=n-1,1,-1
        b(i)=b(i)-sup(i)*b(i+1)
      enddo 
            
      return          
      end                                    